install.packages("h2o")
library(h2o)
h2o.init()                            

#=== AER Ű ִ CreditCard ڷ ó ===#
install.packages("AER")
library(AER)

data("CreditCard",package="AER")    
str(CreditCard)

drops <- c("card","owner","selfemp","share")
num_vars <- CreditCard[, !(names(CreditCard) %in% drops)]  # ġ  

normalize <- function(x) {
  return ((x - min(x)) / (max(x) - min(x)))}    # ȭ Լ  

norm_num_vars <- as.data.frame(lapply(num_vars, normalize)) # ȭ 

share <- CreditCard$share
card <- factor(CreditCard$card)
owner <- factor(CreditCard$owner)   
selfemp <- factor(CreditCard$selfemp) 

data <- as.data.frame(cbind(card,owner,selfemp,norm_num_vars,share))

#=== Ʒڷ ڷ  ===#
set.seed(20180202) 
tr_ind <- sample(1:nrow(data), 1200, replace=F)
tr_data <- data[tr_ind,]
tr_data <- as.h2o(tr_data)
te_data <- data[-tr_ind,]
te_data <- as.h2o(te_data)

#=== н  Ű Ͽ ϱ ===#
# ڴ  н 
ae_model1 <- h2o.deeplearning(x = 1:11, training_frame = tr_data,
                              model_id = "cc_autoencoder1", ignore_const_cols = FALSE,
                              activation = "Tanh",  hidden = c(8,7,5,5), autoencoder = TRUE) 
#  ˰                      
fit1 <- h2o.deeplearning(x = 1:11, y = 12, training_frame = tr_data,
                         ignore_const_cols = FALSE, hidden = c(8,7,5,5),
                         pretrained_autoencoder = "cc_autoencoder1")
perf1 <- h2o.performance(fit1, newdata = te_data)
h2o.mse(perf1)     # ڴ Ͽ н   MSE 
#[]
#0.001800618

#===   Ű  ˰ Ͽ ϱ ===#
fit2 <- h2o.deeplearning(x = 1:11, y = 12, training_frame = tr_data,
                         ignore_const_cols = FALSE, hidden = c(8,7,5,5))
perf2 <- h2o.performance(fit2, newdata = te_data)
h2o.mse(perf2) 
#[]
#0.002386772 

